package vn.vccorp.msh_mesg_tracking_v2;

import android.content.Context;
import android.os.Handler;
import android.os.Looper;

import androidx.annotation.NonNull;

import com.mesglog.sdk.MesgLog;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

public class MessLogV2Plugin implements FlutterPlugin, MethodCallHandler{
    public static final String TAG = MessLogV2Plugin.class.getName();
    public static final String METHOD_CHANNEL_NAME = "mess_log_tracking_v2";
    private MethodChannel methodChannel;
    private Context context;

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
        context = flutterPluginBinding.getApplicationContext();
        methodChannel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), METHOD_CHANNEL_NAME);
        methodChannel.setMethodCallHandler(this);
    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull final Result result) {
        if(call.method.equals("getLibVersion")){
            new Handler().post(new Runnable() {
                @Override
                public void run() {
                    result.success(MesgLog.getLibVersion());
                }
            });
        }else if(call.method.equals("getDeviceId")){
            new Handler(Looper.getMainLooper()).post(new Runnable() {
                @Override
                public void run() {
                    result.success(MesgLog.getDeviceID(context));
                }
            });
        }else if(call.method.equals("handleAppOpen")){
            new Handler(Looper.getMainLooper()).post(new Runnable() {
                @Override
                public void run() {
                    result.success(MesgLog.handlerAppOpen(context));
                }
            });
        }else if(call.method.equals("handleAppQuit")){
            new Handler(Looper.getMainLooper()).post(new Runnable() {
                @Override
                public void run() {
                    result.success(MesgLog.handlerAppQuit(context));
                }
            });
        }else{
            result.notImplemented();
        }
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        methodChannel.setMethodCallHandler(null);
    }
}
