#import "MessLogV2Plugin.h"
#import <SHMesgLog/SHMesgLog.h>

@implementation MessLogV2Plugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    
    FlutterMethodChannel* channel = [FlutterMethodChannel
                                     methodChannelWithName:@"mess_log_tracking_v2"
                                     binaryMessenger:[registrar messenger]];
    MessLogV2Plugin* instance = [[MessLogV2Plugin alloc] init];
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    if([@"handleAppOpen" isEqualToString:call.method]) {
        dispatch_async(dispatch_get_main_queue(), ^{
          [[SHMesgLog shareInstance] handleAppOpen];
          result(@true);
        });
    }else if([@"handleAppQuit" isEqualToString:call.method]) {
        dispatch_async(dispatch_get_main_queue(), ^{
                  [[SHMesgLog shareInstance] handleAppQuit];
                          result(@true);
                });
    }else if ([@"getLibVersion" isEqualToString:call.method]) {
    dispatch_async(dispatch_get_main_queue(), ^{
      result([[SHMesgLog shareInstance] getVersion]);
    });

    }else if([@"getDeviceId" isEqualToString:call.method]){
    dispatch_async(dispatch_get_main_queue(), ^{
      result([[SHMesgLog shareInstance] getDeviceID]);
    });

    }else {
        result(FlutterMethodNotImplemented);
    }
}

@end
