import 'package:flutter/services.dart';
import 'package:msh_mesg_tracking_v2/src/exception/mesg_log_exception.dart';
import 'dart:io' show Platform;

/// MessLogTrackingV2
class MegsLogTrackingV2 {
  static const MethodChannel channel =
      const MethodChannel('mess_log_tracking_v2');

  /// Invoke method channel handleAppQuit native
  static Future<bool> handleAppQuit() async {
    if (Platform.isIOS) {
      var rs = await channel.invokeMethod('handleAppQuit');
      return rs == 1;
    } else if (Platform.isAndroid) {
      return await channel.invokeMethod('handleAppQuit');
    }
    throw MesgLogException(
        "Method handleAppOpen not support current platform !");
  }

  /// Invoke method channel handleAppQuit native
  static Future<bool> handleAppOpen() async {
    if (Platform.isIOS) {
      var rs = await channel.invokeMethod('handleAppOpen');
      return rs == 1;
    } else if (Platform.isAndroid) {
      return await channel.invokeMethod('handleAppOpen');
    }
    throw MesgLogException(
        "Method handleAppOpen not support current platform !");
  }

  /// Invoke method channel getLibVersion native
  static Future<String> get getLibVersion async {
    String version = "Unknown version";
    final String result = await channel.invokeMethod('getLibVersion');
    if (result != null && result.isNotEmpty) {
      version = result;
    }
    return version;
  }

  /// Invoke method channel getDeviceId native
  static Future<String> get getDeviceId async {
    String uuid = "Unknown version";
    final String result = await channel.invokeMethod('getDeviceId');
    if (result != null && result.isNotEmpty) {
      uuid = result;
    }
    return uuid;
  }
}
